/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package tree;

import java.util.Iterator;


public class MyIterator implements Iterator {
    public int index = 0;
    public Node[] allNodes = new Node[0];


    private void add(Node node) {
      Node[] nds = new Node[allNodes.length + 1];
      for (int i = 0; i < allNodes.length; i++) {
        nds[i] = allNodes[i];
      }
      nds[allNodes.length] = node;
      allNodes = nds;
    }

    private void expand(Node node) {
      add(node);
      for (int i = 0; i < node.children.length; i++) {
        expand(node.children[i]);
      }
    }

    public MyIterator(Node[] nodes) {
      for (int i = 0; i < nodes.length; i++) {
        expand(nodes[i]);
      }
    }

    public boolean hasNext() {
      return this.index < this.allNodes.length;
    }

    public Node next() {
      this.index++;
      return this.allNodes[index - 1];
    }
}
